<template>
  <div class="orders">
    <p class="my-3 sm:my-6 text-center sm:text-4xl text-2xl">Заказы <LoadsSpinner v-if="mainLoading" small /></p>
    <div v-if="!orders_photo" class="container">
      <div class="text-3xl mt-14 mb-5 opacity-60 text-center">Здесь пока ничего нет..</div>
      <div v-if="!user" class="opacity-60 text-center mb-14">Войдите в свой профиль или зарегистрируйтесь,<br/>чтобы видеть свою историю заказов</div>
      <div v-else class="opacity-60 text-center mb-14">Вы еще ничего не заказывали<br/>Информация о ваших заказах будет здесь</div>
      <router-link :to="{name: 'Index'}" class="button w-1/2 mx-auto">Перейти на главную</router-link>
    </div>
    <div v-if="orders_photo || orders" class="container">
      <p v-if="orders_photo.length" class="text-2xl sm:text-3xl opacity-70 mt-5">Фотографии</p>
      <div v-if="orders_photo.length" class="wrap-orders py-5">
        <div
          v-for="(el, i) in orders_photo"
          :key="el.order_id"
          class="card flex flex-col">
          <div>
            <p class="text-xl sm:text-2xl opacity-80 mb-2">Заказ №{{el.order_id}}</p>
            <p class="mb-4">{{'Фото: ' + (el.images && el.images.length)+'шт'}}</p>
          </div>
          <div @click="showFullModal(el.order_id, i, 'photos')" class="button">Подробнее</div>
        </div>
      </div>
      <p v-if="orders.length" class="text-2xl sm:text-3xl opacity-70">Продукция</p>
      <div v-if="orders.length" class="wrap-orders py-5">
        <div
          v-for="(order, i) in orders"
          :key="order.order_id"
          class="card flex flex-col">
          <div>
            <p class="text-xl sm:text-2xl opacity-80 mb-2">Заказ №{{order.order_id}}</p>
            <p class="mb-4">{{
                `${order.name === 'puzzles' && 'Пазлы' || order.name === 'cup' && 'Кружка' || (order.name === 'canvas' || order.name === 'canvas_paper') && 'Интерьерная печать'}`
              }}</p>
          </div>
          <div @click="showFullModal(order.order_id, i, 'product')" class="button">Подробнее</div>
        </div>
      </div>
    </div>
    <FullModal v-if="modal" :is-close="false" is-confirm @close="closeFullModal">
      <template v-slot:body>
        <div v-if="selectShowOrder">
          <div class="number-order text-sm sm:text-3xl mb-10">Заказ №{{selectShowOrder}}<LoadsSpinner class="ml-2" v-if="loading" small/></div>
          <div class="flex mb-6">Дата заказа: {{formattedDate(selectOrder.created_at, 'hours')}}</div>
          <div class="order-preview-images">
            <div
              v-for="img in src"
            >
              <div
                class="card h-52 preview-image cursor-pointer"
                :style="{
                background: `url('${img.file}')`,
                backgroundPosition: 'center',
                backgroundSize: 'cover',
                backgroundRepeat: 'no-repeat'
              }"
                @click="openImage(img.file)"
              >
                <span>{{img.size}}</span>
              </div>
            </div>
          </div>
        </div>
      </template>
    </FullModal>
    <FullModal v-if="modalProduct" :is-close="false" is-confirm @close="closeFullModal">
      <template v-slot:body>
        <div v-if="selectShowOrder">
          <div class="number-order text-sm sm:text-3xl mb-10">Заказ №{{selectShowOrder}}<LoadsSpinner class="ml-2" v-if="loading" small/></div>
          <div class="flex mb-6">Дата заказа: {{formattedDate(selectOrder.created_at, 'hours')}}</div>
        </div>
      </template>
    </FullModal>
  </div>
</template>

<script>
import {useStore} from "vuex";
import {computed, onMounted, reactive, ref} from "vue";
import {supabase} from "../supabase";
import FullModal from "../components/FullModal.vue";
import LoadsSpinner from "../components/Loads-spinner.vue";
import formattedDate from '../utils/formatDate.js'
export default {
  name: "Orders",
  components: {LoadsSpinner, FullModal},
  setup() {
    const store = useStore()
    let user = computed(function () {
      return store.state.user
    });

    const loading = ref(true)
    const mainLoading = ref(true)
    const modal = ref(false)
    const modalProduct = ref(false)
    const selectShowOrder = ref(null)

    const orders_photo = ref([])
    const orders = ref([])
    async function getOrdersPhoto() {
      try {
        loading.value = true
        user = supabase.auth.user()

        let { data, error, status } = await supabase
          .from("orders_photo")
          .select(`created_at, images, order_id`)

        if (error && status !== 406) throw error

        if (data) {
          orders_photo.value = data
        }
      } catch (error) {
        console.log(error.message)
      } finally {
        loading.value = false
      }
    }
    async function getOrders() {
      try {
        loading.value = true
        user = supabase.auth.user()

        let { data, error, status } = await supabase
          .from("orders")
          .select(`created_at, name, order_id`)

        if (error && status !== 406) throw error

        if (data) {
          orders.value = data
        }
        mainLoading.value = false
      } catch (error) {
        console.log(error.message)
      } finally {
        loading.value = false
      }
    }

    const selectOrder = ref([])
    async function showFullModal(id, index, type) {
      if (type === 'product') {
        modalProduct.value = true
        selectShowOrder.value = id
        selectOrder.value = orders.value[index]
      } else {
        modal.value = true
        selectShowOrder.value = id
        await downloadImage(index)
        selectOrder.value = orders_photo.value[index]
      }
    }

    function closeFullModal() {
      modal.value = false
      modalProduct.value = false
      src.value = []
      selectShowOrder.value = null
    }

    function openImage(el) {
      window.open(el)
    }

    const src = ref([])
    const downloadImage = (index) => {
      try {
        async function getImagesSupabase(el) {
          loading.value = true
          const { data, error } = await supabase.storage
            .from(`orders/photo/${selectShowOrder.value}/${el.size}`)
            .download(el.name)
          if (error) throw error
          src.value.push({
            size: el.size,
            file: URL.createObjectURL(data)
          })
          loading.value = false
        }
        orders_photo.value[index].images.forEach( img => {
          getImagesSupabase(img)
        })
      } catch (error) {
        console.error("Error downloading image: ", error.message)
      } finally {
      }
    }

    onMounted(async () => {
      await getOrdersPhoto()
      await getOrders()
    })
    return {
      user,
      modal,
      modalProduct,
      orders_photo,
      orders,
      selectShowOrder,
      selectOrder,
      src,
      loading,
      mainLoading,
      openImage,
      formattedDate,
      showFullModal,
      closeFullModal,
    }
  }
}
</script>

<style scoped lang="scss">
.orders {
  .wrap-orders {
    display: grid;
    grid-template-columns: 1fr 1fr 1fr;
    grid-column-gap: 10px;
    grid-row-gap: 1em;
    @media (max-width: 768px) {
      grid-template-columns: 1fr 1fr;
    }
    @media (max-width: 650px) {
      grid-template-columns: 1fr;
    }
  }
  .order-preview-images {
    display: grid;
    grid-template-columns: 1fr 1fr 1fr 1fr 1fr;
    grid-column-gap: 10px;
    grid-row-gap: 1em;
    @media (max-width: 768px) {
      grid-template-columns: 1fr 1fr 1fr;
    }
    @media (max-width: 650px) {
      grid-template-columns: 1fr 1fr;
    }
    .preview-image {
      position: relative;
      span {
        position: absolute;
        bottom: 0;
        padding: 5px 10px;
        border-radius: 5px;
        background-color: rgba(0,0,0,.3);
        left: 50%;
        transform: translate(-50%, -50%);
        cursor: pointer;
        &:hover {
          background-color: rgba(0,0,0,.7);
        }
      }
    }
  }
}
</style>
